/*
 * FITSHead.java
 *
 * Copyright (C) 1998-2000 Taichi Kato
 *
 * Original package is jp.ac.kyoto-u.kusastro.ooruri.
 *
 */

package misao.contrib.imdisp;

import java.io.*;

public class FITSHead extends HeadBase {
	FITSHead() {
		super();
	}

	FITSHead(DataInput ds) {
		int lines = 0;
		while (true) {
			FITSHeadLine h = new FITSHeadLine(ds);
			if (h.isEnd()) {
				lines++;
				break;
			}
			if (lines == 0 && !h.item().equals("SIMPLE") && !h.value().equals("T")) {
				return;
			}
			hash.put(h.item(),h.value());
			lines++;
		}
		int block = lines/36;
		int residual = lines-block*36;
		if (residual > 0) {
			skip(ds,36-residual);
		}
	}

	private void skip(DataInput ds,int n) {
		byte buf[] = new byte[80*n];
		try {
			ds.readFully(buf,0,80*n);
		}
		catch (IOException e) {
			System.out.println("Exception: " + e.toString());
		}
	}
}
