/*
 * MisaoPreliminaryObject.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.database;

import misao.util.*;
import misao.host.*;

public class MisaoPreliminaryObject extends ReferenceName {
    private Coor coor;
    private double pos_error;	// arcsec

    public MisaoPreliminaryObject ( Coor _coor, double _pos_error ) {
	super(createName(_coor, _pos_error), ReferenceType.REF_S);

	coor = _coor;
	pos_error = _pos_error;

    }

    public MisaoPreliminaryObject ( String s ) {
	super(createName(Coor.createCoor(s.substring(1,3) + " " + s.substring(3,5) + " " + s.substring(5,10) + " " + s.substring(10,13) + " " + s.substring(13,15) + " " + s.substring(15,19)), Double.valueOf(s.substring(20)).doubleValue()), ReferenceType.REF_S);

	coor = Coor.createCoor(s.substring(1,3) + " " + s.substring(3,5) + " " + s.substring(5,10) + " " + s.substring(10,13) + " " + s.substring(13,15) + " " + s.substring(15,19));
	pos_error = Double.valueOf(s.substring(20)).doubleValue();
    }

    private static String createName ( Coor coor, double pos_error ) {
	String s = coor.toStringRA() + coor.toStringDecl() + "-" + Astro.toString(pos_error, 10, 8).trim();
	String name = "J";
	for (int i = 0 ; i < s.length() ; i++) {
	    if (s.charAt(i) != ' ')
		name += s.charAt(i);
	}
	return name;
    }

    public Coor getCoor ( ) {
	return coor;
    }

    public double getPositionError ( ) {
	return pos_error;
    }
}
