/*
 * DifferentialPxfFile.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.diff;

import java.io.*;
import misao.util.*;
import misao.pixy.*;

public class DifferentialPxfFile implements Printable {
    public DifferentialImageInformation image_info;
    public PairList pair_list;

    public DifferentialPxfFile ( ) {
	image_info = null;
	pair_list = null;
    }

    public DifferentialPxfFile ( DifferentialImageInformation _image_info, PairList _pair_list ) {
	this();

	image_info = _image_info;
	pair_list = _pair_list;
    }

    public void print ( PrintStream ps ) {
	if (image_info != null) {
	    ps.println("[Image Information]");
	    image_info.print(ps);
	    ps.println("");
	}

	if (pair_list != null) {
	    if (pair_list.isOutputStatistics()) {
		ps.println("[Statistics]");
		pair_list.printStatistics(ps);
		ps.println("");
	    }
	    if (pair_list.isOutputAllData()) {
		ps.println("[Data]");
		pair_list.printData(ps);
		ps.println("");
	    }
	}
    }
}
