/*
 * AdjoiningPixelSet.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.pixy;

import java.awt.*;
import java.lang.Math;
import java.util.Vector;
import misao.util.*;

public class AdjoiningPixelSet {
    private Vector ap_list;
    private int ptr;

    public AdjoiningPixelSet ( ) {
	ap_list = new Vector();
	ptr = 0;
    }

    public void add ( AdjoiningPixel ap ) {
	ap_list.addElement(ap);
    }

    public int size ( ) {
	return ap_list.size();
    }

    public AdjoiningPixel getFirstElement ( ) {
	ptr = 0;
	return getNextElement();
    }

    public AdjoiningPixel getNextElement ( ) {
	AdjoiningPixel ap = null;
	if (ptr < ap_list.size()) {
	    ap = (AdjoiningPixel)ap_list.elementAt(ptr);
	    ptr++;
	}
	return ap;
    }

    public ImageRGB createImage ( Size size ) throws Exception {
	ImageRGB image = new ImageRGB(size);

	AdjoiningPixel ap = getFirstElement();
	while (ap != null) {
	    double r = Math.random();
	    double g = Math.random();
	    double b = Math.random();
	    for (int i = 0 ; i < ap.size() ; i++) {
		Point ad_pt = ap.elementPointAt(i);
		image.setRValue(ad_pt, r);
		image.setGValue(ad_pt, g);
		image.setBValue(ad_pt, b);
	    }
	}

	return image;
    }
}
