/*
 * MatchingCatalogCanvas.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.pixy.test;

import java.awt.*;
import java.util.*;
import misao.util.*;
import misao.pixy.*;

public class MatchingCatalogCanvas extends CatalogCanvas {
    TriGraph tri_graph;

    public MatchingCatalogCanvas ( Frame frame, StarList list, MapFunction mf, Size sz, Position base, double mag, TriGraph g ) {
	super(frame, list, mf, sz, base, mag);

	tri_graph = g;
    }

    protected void drawBackground ( Graphics g, Size s ) {
	g.setColor(Color.magenta);

	int n = tri_graph.getNodeCount();
	for (int i = 0 ; i < n ; i++) {
	    StarData sd1 = tri_graph.getNodeAt(i);
	    Point pt1 = getStarPoint(sd1.getPosition());
	    for (int j = i + 1 ; j < n ; j++) {
		if (tri_graph.isConnected(i, j)) {
		    StarData sd2 = tri_graph.getNodeAt(j);
		    Point pt2 = getStarPoint(sd2.getPosition());
		    g.drawLine(pt1.x, pt1.y, pt2.x, pt2.y);
		}
	    }
	}
    }
}
