/*
 * MatchingChartFrame.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.pixy.test;

import java.awt.*;
import misao.util.*;
import misao.pixy.*;

public class MatchingChartFrame extends ChartFrame {
    private MatchingCatalogCanvas matching_catalog_canvas;

    private TriGraph graph;

    private Checkbox checkGraph;

    public MatchingChartFrame ( String title, StarList list, Size s, MapFunction f, Position p, double mag, TriGraph g ) {
	star_list = list;
	size = s;
	mf = f;
	pos = p;
	faintest_mag = mag;
	graph = g;

	init();

	setTitle("PIXY system - " + title);
	setSize(size.getWidth() + 10, size.getHeight() + 40 + 25);
	setVisible(true);
    }

    public void init ( ) {
	checkBgBlack = new Checkbox("Black Background");
	checkBgBlack.setState(false);
	checkGraph = new Checkbox("Graph");
	checkGraph.setState(false);
	btnView = new Button("View");

	Panel panel = new Panel(new FlowLayout());
	panel.add(checkBgBlack);
	panel.add(checkGraph);
	panel.add(btnView);

	catalog_canvas = new MatchingCatalogCanvas(this, star_list, mf, size, pos, faintest_mag, graph);

	if (checkGraph.getState())
	    catalog_canvas.enableDrawBackground();
	else
	    catalog_canvas.disableDrawBackground();

	setLayout(new BorderLayout());
	add("North",  panel);
	add("Center", catalog_canvas);
    }

    public boolean action (Event ev, Object obj) {
	if (ev.target instanceof Button) {
	    if (btnView.getLabel().equals(obj)) {
		if (checkGraph.getState())
		    catalog_canvas.enableDrawBackground();
		else
		    catalog_canvas.disableDrawBackground();
	    }
	}

	return super.action(ev, obj);
    }
}
