/*
 * ReferenceCatalog.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.ref;

import java.io.*;
import misao.pixy.*;
import misao.util.*;
import misao.host.*;

public abstract class ReferenceCatalog {
    protected String path;
    protected DataInputStream dis;

    abstract public ReferenceData createReferenceData ( String record );

    public void setPath ( String p ) {
	path = p;
    }

    public ReferenceData readFirstData ( ) {
	try {
	    File file = new File(path);
	    FileInputStream fis = new FileInputStream(file);
	    dis = new DataInputStream(new BufferedInputStream(fis));

	    return readNextData();
	} catch (IOException e) {
	    return null;
	}
    }

    public ReferenceData readNextData ( ) {
	if (dis == null)
	    return null;

	String record = "";
	try {
	    record = dis.readLine();
	    if (record == null) {
		dis.close();
		return null;
	    }
	} catch (IOException e) {
	    return null;
	}

	ReferenceData data = createReferenceData(record);
	if (data == null)
	    return readNextData();

	return data;
    }
}
