/*
 * Fastt.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

/*
 * Data format sample
 * 
   1 & A01020061 & 00:34:44.8621 &  00:54:20.660 & 14.20 & 0.10 & 1.00 & 0.02 &  7 & \nodata &         \nl
   2 & A01020146 & 00:35: 4.7921 &  01:08:45.702 & 17.36 & 0.30 & 1.04 & 0.07 &  6 & \nodata &         \nl
 *
 */

package misao.ref.catalog;

import java.util.*;
import misao.pixy.*;
import misao.util.*;
import misao.host.*;
import misao.ref.*;

public class Fastt extends ReferenceCatalog {
    public Fastt ( ) {
    }

    public ReferenceData createReferenceData ( String record ) {
	StringTokenizer st = new StringTokenizer(record, "&");
	if (st.countTokens() < 11)
	    return null;

	String name = "HS" + st.nextToken().trim();
	boolean mark = false;
	if (name.charAt(name.length() - 1) == '*') {
	    name = name.substring(0, name.length() - 1);
	    mark = true;
	}
	String dbvs_name = name;
	String Star = st.nextToken().trim();
	String RA = st.nextToken().trim();
	String Decl = st.nextToken().trim();
	String R_F = st.nextToken().trim();
	String sigma_R_F = st.nextToken().trim();
	String xy = st.nextToken().trim();
	String sigma_xy = st.nextToken().trim();
	String nobs = st.nextToken().trim();
	String Type = st.nextToken().trim();
	String Notes = st.nextToken().trim();

	String ra = RA.replace(':', ' ');
	String decl = Decl.replace(':', ' ');

	if (Type.equals("\\nodata"))
	    Type = "";

	int p = Notes.indexOf("\\nl");
	if (p >= 0)
	    Notes = Notes.substring(0,p).trim();
	if (Notes.length() > 0) {
	    if (Notes.charAt(0) == '$')
		Notes = Notes.substring(1, Notes.length() - 1);
	}

	CoorMapping coor = new CoorMapping(Coor.createCoor(ra + " " + decl));

	record = name;
	if (mark)
	    record += "*";
	record += "  R.A. " + RA + "  Decl. " + Decl;
	record += "  R_F:" + R_F + " mag (sigma " + sigma_R_F + " mag)";
	record += "  Star:" + Star;
	if (nobs.length() > 0)
	    record += "  " + nobs + " obs";
	if (Type.length() > 0)
	    record += "  Type:" + Type;
	if (Notes.length() > 0)
	    record += "  " + Notes;

	ReferenceData data = new ReferenceData(name, dbvs_name, coor, record);

	return data;
    }
}
