/*
 * MisEGsc.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

/*
 * Data format sample
 * 
MisE.GSC -- Errors in the Guide Star Catalog discovered by the MISAO Project.

ID             GSC ID    R.A.      Decl.     Mag   Observation                  Existence
------------------------------------------------------------------------------------------
MisE.GSC.00001 1846.1273 051536.09 +242133.3  7.82 1998 Nov 20.74730 <8.8R
 *
 */

package misao.ref.catalog;

import misao.pixy.*;
import misao.util.*;
import misao.host.*;
import misao.ref.*;

public class MisEGsc extends ReferenceCatalog {
    public MisEGsc ( ) {
    }

    public ReferenceData createReferenceData ( String record ) {
	if (record.length() < 52)
	    return null;
	if (! record.substring(0, 9).equals("MisE.GSC."))
	    return null;

	if (record.length() > 80)
	    return null;

	String name = record.substring(0, 14);
	String dbvs_name = name.toUpperCase();

	CoorMapping coor = new CoorMapping(Coor.createCoor(record.substring(25,44)));

	record = record.substring(0,15) + "GSC" + record.substring(15,51) + "[" + record.substring(51) + "]";

	ReferenceData data = new ReferenceData(name, dbvs_name, coor, record);

	return data;
    }
}
