/*
 * MisEUa1.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

/*
 * Data format sample
 * 
MisE.UA1 -- Errors in the USNO-A1.0 discovered by the MISAO Project.

ID             USNO-A1.0 ID  R.A.       Decl.      Rmag Bmag Observation                  Existence
----------------------------------------------------------------------------------------------------
MisE.UA1.00001 1275.06752214 065826.595 +410846.26 15.4 16.2 1998 Nov 28.68854 <16.7C     MisF.00001
 *
 */

package misao.ref.catalog;

import misao.pixy.*;
import misao.util.*;
import misao.host.*;
import misao.ref.*;

public class MisEUa1 extends ReferenceCatalog {
    public MisEUa1 ( ) {
    }

    public ReferenceData createReferenceData ( String record ) {
	if (record.length() < 62)
	    return null;
	if (! record.substring(0, 9).equals("MisE.UA1."))
	    return null;

	if (record.length() > 90)
	    return null;

	String name = record.substring(0, 14);
	String dbvs_name = name.toUpperCase();

	CoorMapping coor = new CoorMapping(Coor.createCoor(record.substring(29,50)));

	String record0 = record.substring(0,15) + "USNO" + record.substring(15,51);
	String rmag = record.substring(51,55);
	if (rmag.charAt(2) == ' ')
	    rmag = "";
	else
	    rmag += "R ";
	String bmag = record.substring(56,60);
	if (bmag.charAt(2) == ' ')
	    bmag = "";
	else
	    bmag += "B ";
	record0 = record0 + rmag + bmag + "[" + record.substring(61) + "]";

	ReferenceData data = new ReferenceData(name, dbvs_name, coor, record0);

	return data;
    }
}
