/*
 * Rosat.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

/*
 * Data format sample
 * 
      ROSAT source     optical (J2000.0) mag classification
 -----------------------------------------------------------
  1RXSJ000154.2-670749 000154.9 -670747 13.4 CV EC23593-6
 *
 */

package misao.ref.catalog;

import java.util.*;
import misao.pixy.*;
import misao.util.*;
import misao.host.*;
import misao.ref.*;

public class Rosat extends ReferenceCatalog {
    public Rosat ( ) {
    }

    public ReferenceData createReferenceData ( String record ) {
	if (record.length() < 40  ||  ! record.substring(0,7).equals("  1RXSJ"))
	    return null;

	record = record.trim();

	StringTokenizer st = new StringTokenizer(record);
	String name = st.nextToken();
	String dbvs_name = name;
	String ra = st.nextToken();
	String decl = st.nextToken();

	CoorMapping coor = new CoorMapping(Coor.createCoor(ra + " " + decl));

	ReferenceData data = new ReferenceData(name, dbvs_name, coor, record);

	return data;
    }
}
