/*
 * CdromList.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.util;

import java.io.*;

public abstract class CdromList extends CatalogList {
    public abstract void load ( Coor center_coor, double fov, double mag, String[] path_list ) throws Exception;

    public File checkCdrom ( String[] path_list, String filename ) throws Exception {
	return checkCdrom(path_list, filename, null);
    }
    public File checkCdrom ( String[] path_list, String filename, String disc_name ) throws Exception {
	DataInputStream system_in = new DataInputStream(System.in);

	if (disc_name == null)
	    disc_name = "the disc";

	for (int i = 0 ; i < path_list.length ; i++) {
	    String path = path_list[i] + "/" + filename;

	    File file = new File(path);
	    if (file.canRead())
		return file;

	    file = new File(path.toLowerCase());
	    if (file.canRead())
		return file;

	    file = new File(path.toUpperCase());
	    if (file.canRead())
		return file;
	}

	throw new CdromNotFoundException("Insert " + disc_name + " and press the RETURN key.");
    }
}
