/*
 * CelestialMapIndex.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.util;

import java.util.*;

public class CelestialMapIndex extends MapIndex {
    public CelestialMapIndex ( ) {
	super(0, 360, -90, 90, 24, 18);
    }

    public Vector findElementByPosition ( Coor coor, double dist ) {
	Vector list = new Vector();

	AreaManager area_manager = new AreaManager(coor, dist);
	for (int i = 0 ; i < 24 ; i++) {
	    for (int j = 0 ; j < 18 ; j++) {
		int ra = i;
		int decl = j * 10 - 90;
		Coor start_coor = new Coor(ra * 15, decl);
		Coor end_coor = new Coor((ra + 1) * 15, decl + 10);
		if (area_manager.overlapArea(start_coor, end_coor)) {
		    for (int k = 0 ; k < map[i][j].size() ; k++)
			list.addElement(map[i][j].elementAt(k));
		}
	    }
	}

	return list;
    }
}
