/*
 * CgiListUSNOVizieR.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.util;

public class CgiListUSNOVizieR extends CgiList {
    protected static final String urlCGI = "http://vizier.u-strasbg.fr/cgi-bin/PMM-USNO-A1.0";

    protected static final int USNO_V = 0;
    protected static final int USNO_R = 1;
    protected static final int USNO_B = 2;

    private int mode;

    public CgiListUSNOVizieR ( ) {
	super();

	mode = USNO_V;
    }

    public void setModeRmag ( ) {
	mode = USNO_R;
    }
    public void setModeBmag ( ) {
	mode = USNO_B;
    }

    public void load ( Coor center_coor, double fov, double mag ) throws Exception {
	try {
	    load(center_coor, fov, mag, mode);
	} catch (Exception e) {
	    throw e;
	}
    }

    public void loadRmag ( Coor center_coor, double fov, double mag ) throws Exception {
	try {
	    load(center_coor, fov, mag, USNO_R);
	} catch (Exception e) {
	    throw e;
	}
    }

    public void loadBmag ( Coor center_coor, double fov, double mag ) throws Exception {
	try {
	    load(center_coor, fov, mag, USNO_B);
	} catch (Exception e) {
	    throw e;
	}
    }

    private void load ( Coor center_coor, double fov, double mag, int mag_type ) throws Exception {
	setUnit(fov);

	String arg = "?-out.max=10000&-c=" + center_coor.getRA_h() + "+" + center_coor.getRA_m() + "+" + center_coor.getRA_s() + "+" + (center_coor.getDecl() < 0.0 ? "-" : "%2B") + center_coor.getAbsDecl_d() + "+" + center_coor.getAbsDecl_m() + "+" + center_coor.getAbsDecl_s() + "&-c.eq=2000&-c.geom=b&-c.r=" + String.valueOf(fov) + "&-c.u=deg&-id=&-lB0=-2&-lB1=";

	if (mag_type == USNO_V) {
	    String arg2 = String.valueOf(mag) + "&-lR0=-2&-lR1=100&-lc0=-100&-lc1=100";
	    read(arg + arg2, 1, center_coor, fov, mag, mag_type);
	    arg2 = "100&-lR0=-2&-lR1=" + String.valueOf(mag) + "&-lc0=-100&-lc1=100";
	    read(arg + arg2, 2, center_coor, fov, mag, mag_type);
	} else if (mag_type == USNO_R) {
	    String arg2 = "100&-lR0=-2&-lR1=" + String.valueOf(mag) + "&-lc0=-100&-lc1=100";
	    read(arg + arg2, 1, center_coor, fov, mag, mag_type);
	} else if (mag_type == USNO_B) {
	    String arg2 = String.valueOf(mag) + "&-lR0=-2&-lR1=100&-lc0=-100&-lc1=100";
	    read(arg + arg2, 1, center_coor, fov, mag, mag_type);
	}
    }

    private void read ( String arg, int phase, Coor center_coor, double fov, double mag, int mag_type ) throws Exception {
	try {
	    openConnectionGet(urlCGI + arg);
	} catch ( Exception e ) {
	    throw e;
	}

	String record = null;
	double mR;
	double mB;
	double mV;
	double m;

	try {
	    record = readLine();
	} catch ( Exception e ) {
	    throw e;
	}

	while (record != null) {
	    if (record.length() == 71) {
		if ('0' <= record.charAt(0)  &&  record.charAt(0) <= '2'  &&
		    '0' <= record.charAt(1)  &&  record.charAt(1) <= '9'  &&
		    '0' <= record.charAt(2)  &&  record.charAt(2) <= '9'  &&
		    '0' <= record.charAt(3)  &&  record.charAt(3) <= '9'  &&
		    record.charAt(4) == '-'  &&
		    '0' <= record.charAt(5)  &&  record.charAt(5) <= '9'  &&
		    '0' <= record.charAt(6)  &&  record.charAt(6) <= '9'  &&
		    '0' <= record.charAt(7)  &&  record.charAt(7) <= '9'  &&
		    '0' <= record.charAt(8)  &&  record.charAt(8) <= '9'  &&
		    '0' <= record.charAt(9)  &&  record.charAt(9) <= '9'  &&
		    '0' <= record.charAt(10)  &&  record.charAt(10) <= '9'  &&
		    '0' <= record.charAt(11)  &&  record.charAt(11) <= '9'  &&
		    '0' <= record.charAt(12)  &&  record.charAt(12) <= '9'  &&
		    record.charAt(13) == ' '  &&
		    '0' <= record.charAt(14)  &&  record.charAt(14) <= '9'  &&
		    '0' <= record.charAt(15)  &&  record.charAt(15) <= '9'  &&
		    record.charAt(16) == ':'  &&
		    '0' <= record.charAt(17)  &&  record.charAt(17) <= '9'  &&
		    '0' <= record.charAt(18)  &&  record.charAt(18) <= '9'  &&
		    record.charAt(19) == ':'  &&
		    '0' <= record.charAt(20)  &&  record.charAt(20) <= '9'  &&
		    '0' <= record.charAt(21)  &&  record.charAt(21) <= '9'  &&
		    record.charAt(22) == '.'  &&
		    '0' <= record.charAt(23)  &&  record.charAt(23) <= '9'  &&
		    '0' <= record.charAt(24)  &&  record.charAt(24) <= '9'  &&
		    '0' <= record.charAt(25)  &&  record.charAt(25) <= '9'  &&
		    '0' <= record.charAt(27)  &&  record.charAt(27) <= '9'  &&
		    '0' <= record.charAt(28)  &&  record.charAt(28) <= '9'  &&
		    record.charAt(29) == ':'  &&
		    '0' <= record.charAt(30)  &&  record.charAt(30) <= '9'  &&
		    '0' <= record.charAt(31)  &&  record.charAt(31) <= '9'  &&
		    record.charAt(32) == ':'  &&
		    '0' <= record.charAt(33)  &&  record.charAt(33) <= '9'  &&
		    '0' <= record.charAt(34)  &&  record.charAt(34) <= '9'  &&
		    record.charAt(35) == '.'  &&
		    '0' <= record.charAt(36)  &&  record.charAt(36) <= '9'  &&
		    '0' <= record.charAt(37)  &&  record.charAt(37) <= '9'  &&
		    record.charAt(60) == ';') {

		    // R.A. and Decl.
		    CoorMapping coor = new CoorMapping(Integer.parseInt(record.substring(14,16)), Integer.parseInt(record.substring(17,19)), (double)(Float.valueOf(record.substring(20,26)).floatValue()), (record.charAt(26) == '-'), Integer.parseInt(record.substring(27,29)), Integer.parseInt(record.substring(30,32)), (double)(Float.valueOf(record.substring(33,38)).floatValue()));

		    // R mag
		    mR = ((double)(Float.valueOf(record.substring(46,50).trim()).floatValue()));
		    // B mag
		    mB = ((double)(Float.valueOf(record.substring(41,45).trim()).floatValue()));
		    // preliminary V mag
		    if (mR < 99.9) {
			if (mB < 99.9) {
			    mV = Astro.getUSNOVmag(mR, mB);
			} else {
			    mV = mR;
			}
		    } else {
			mV = mB;
		    }
		    // magnitude
		    if (mag_type == USNO_R) {
			if (mR < 99.9)
			    m = mR;
			else
			    m = mV;
		    } else if (mag_type == USNO_B) {
			if (mB < 99.9)
			    m = mB;
			else
			    m = mV;
		    } else {
			m = mV;
		    }

		    if (m <= mag  &&  (phase == 1  ||  mB >= mag)) {
			String id = "USNO" + record.substring(0,13);
			if (isModeSimple()) {
			    record = id + "  " + record.substring(14,16) + " " + record.substring(17,19) + " " + record.substring(20,26) + "  " + record.substring(26,29) + " " + record.substring(30,32) + " " + record.substring(33,38) + "  " + record.substring(46,50) + "R  " + record.substring(41,45) + "B";
			    if (mV < 99.9  &&  mR < 99.9  &&  mB < 99.9) {
				record += "  (" + Astro.toString(mV, 5, 2) + "V)";
			    }
			} else if (isModeDetail()) {
			    record = id + "  R.A.=" + record.substring(14,16) + " " + record.substring(17,19) + " " + record.substring(20,26) + "  Decl.=" + record.substring(26,29) + " " + record.substring(30,32) + " " + record.substring(33,38) + "  epoch=" + record.substring(51,59) + "  Mag(R)=" + record.substring(46,50) + "  Mag(B)=" + record.substring(41,45);
			    if (mV < 99.9  &&  mR < 99.9  &&  mB < 99.9) {
				record += "  (preliminary V mag=" + Astro.toString(mV, 5, 2) + ")";
			    }
			} else {
			    id = null;
			    record = null;
			}

			addStar(center_coor, coor, m, id, record);
		    }
		}
	    }

	    try {
		record = readLine();
	    } catch ( Exception e ) {
		throw e;
	    }
	}
	close();
    }
}
