/*
 * Histogram.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.util;

public class Histogram {
    private int h[];
    private int a[];
    private int steps;

    public Histogram ( int n ) {
	steps = n;
	h = new int[steps];
	a = new int[steps];
	for (int i = 0 ; i < steps ; i++) {
	    h[i] = 0;
	    a[i] = 0;
	}
    }

    public void addAt ( int g ) {
	addAt(g, 1);
    }

    public void addAt ( int g, int val ) {
	if (g < 0)
	    g = 0;
	if (g >= steps)
	    g = steps - 1;
	h[g] += val;
    }

    public void accumulate ( ) {
	int p = 0;
	for (int i = 0 ; i < steps ; i++) {
	    p += h[i];
	    a[i] = p;
	}
    }

    public int getAccumulationAt ( int g ) {
	return a[g];
    }

    public int getAccumulationIndex ( int p ) {
	for (int i = 0 ; i < steps ; i++) {
	    if (p <= a[i])
		return i;
	}
	return steps - 1;
    }

    public double getAccumulation ( int p ) {
	int index = getAccumulationIndex(p);
	if (h[index] == 0)
	    return (double)index;
	int base = a[index] - h[index];
	return (double)(p - base) / (double)h[index] + (double)(index - 1);
    }
}
