/*
 * Position.java
 *
 * Copyright (C) 1998-2000 Seiichi Yoshida
 *
 */

package misao.util;

public class Position {
    private double x;
    private double y;

    public Position () {
	x = y = 0.0;
    }

    public Position ( double X, double Y ) {
	x = X;
	y = Y;
    }

    public Position ( Position pos ) {
	x = pos.getX();
	y = pos.getY();
    }

    public Position ( Xyz xyz ) {
	x = xyz.getX();
	y = xyz.getY();
    }

    public double getX ( ) {
	return x;
    }

    public double getY ( ) {
	return y;
    }

    public void set ( Position pos ) {
	x = pos.x;
	y = pos.y;
    }

    public void setX ( double X ) {
	x = X;
    }

    public void setY ( double Y ) {
	y = Y;
    }

    public void add ( Position pos ) {
	x += pos.x;
	y += pos.y;
    }

    public void rescale ( double r ) {
	x *= r;
	y *= r;
    }

    public String toString ( ) {
	return "Position: x = " + x + ", y = " + y;
    }
}
